# std::logic_error

From cppreference.com
< cpp‎ | error

Defined in header `<stdexcept>` |  |
class logic_error; |  |

Defines a type of object to be thrown as exception. It reports errors that are a consequence of faulty logic within the program such as violating logical preconditions or class invariants and may be preventable.

No standard library components throw this exception directly, but the exception types std::invalid_argument, std::domain_error, std::length_error, std::out_of_range, std::future_error, and `std::experimental::bad_optional_access` are derived from `std::logic_error`.

Inheritance diagram

### Member functions

(constructor) | constructs the exception object (public member function)

## std::logic_error::logic_error

explicit logic_error( const std::string& what_arg ); | (1) |
explicit logic_error( const char* what_arg ); | (2) | (since C++11)

Constructs the exception object with `what_arg` as explanatory string that can be accessed through what().

Because copying `std::exception` is not permitted to throw exceptions, this message is typically stored internally as a separately-allocated reference-counted string. This is also why there is no constructor taking `std::string&&`: it would have to copy the content anyway.

### Parameters

what_arg | - | explanatory string

### Exceptions

May throw std::bad_alloc

## Inherited from std::exception

### Member functions

(destructor) [virtual] | destructs the exception object (virtual public member function of `std::exception`)
what [virtual] | returns an explanatory string (virtual public member function of `std::exception`)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/error/logic_error&oldid=80278"